//=====================================================================
//
//	PD.h - j1UBL project design defs
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(PD_H)
#define PD_H
	
//#include <project.h>

#define	PD_PARAM_BL_SELECT				(2u)
#define	PD_PARAM_BL_SELECT_CYBL			(1u)
#define	PD_PARAM_BL_SELECT_J1UBL			(2u)
#define	PD_PARAM_J1UBL_ENABLED			(1u)
#define	PD_PARAM_SD_ENABLED				(1u)
#define	PD_PARAM_SF_ENABLED				(0u)
#define	PD_PARAM_ETH_ENABLED				(0u)
#define	PD_PARAM_USB_ENABLED				(1u)
#define PD_PARAM_HY28B_ENABLED			(1u)
#define PD_PARAM_HY28B_BL_ENABLED			(1u)
#define PD_PARAM_HY28B_LCD_PAR_MODE		(1u)
#define PD_PARAM_HY28B_LCD_SPI_MODE		(0u)
#define PD_PARAM_HY28B_TOUCH_SPI_ENABLE	(0u)
#define PD_PARAM_HY28B_TOUCH_SPI_SHARED	(0u)
#define PD_PARAM_HB1_ENABLED				(1u)
#define PD_PARAM_HB2_ENABLED				(1u)
#define	PD_PARAM_DEVICE_NAME				"SAK-PROTO v1.5"
#define PD_PARAM_J1CONSOLE_ENABLED		(1u)
#define PD_PARAM_UART_ENABLED				(0u)
#define	PD_PARAM_ARTNET_OEM_CODE			(0u)
#define	PD_PARAM_XP_ENABLED				(0u)

//#include "main.h"

#if defined(CYDEV_BOOTLOADER_IO_COMP)

	#if (PD_PARAM_BL_SELECT == PD_PARAM_BL_SELECT_CYBL)
		#if ((CYDEV_BOOTLOADER_IO_COMP == CyBtldr_Custom_Interface) && PD_PARAM_USB_ENABLED)
			#define CyBtldrCommStart        PD_USBFS_CyBtldrCommStart
			#define CyBtldrCommStop         PD_USBFS_CyBtldrCommStop
			#define CyBtldrCommReset        PD_USBFS_CyBtldrCommReset
			#define CyBtldrCommWrite        PD_USBFS_CyBtldrCommWrite
			#define CyBtldrCommRead         PD_USBFS_CyBtldrCommRead
		#endif	// (CYDEV_BOOTLOADER_IO_COMP == CyBtldr_Custom_Interface && PD_PARAM_USB_ENABLED)
	#endif	// (PD_PARAM_BL_SELECT == PD_PARAM_BL_SELECT_CYBL)	

	#if (PD_PARAM_BL_SELECT == PD_PARAM_BL_SELECT_J1UBL)
		#define	PD_COMM_XXX
		#define CyBtldrCommStart        PD_CommStart
		#define CyBtldrCommStop         PD_CommStop
		#define CyBtldrCommReset        PD_CommReset
		#define CyBtldrCommWrite        PD_CommWrite
		#define CyBtldrCommRead         PD_CommRead
		#define	CyBtldrCommCmd			PD_CommCmd
		
	    extern void PD_CommStart(void);
	    extern void PD_CommStop (void);
    	extern void PD_CommReset(void);
    	extern cystatus PD_CommWrite(uint8* buffer, uint16 size, uint16* count, uint8 timeOut);
    	extern cystatus PD_CommRead (uint8* buffer, uint16 size, uint16* count, uint8 timeOut);
		
	    extern uint8 PD_CommCmd(uint8* pktBfr, uint16 pktDataSize, uint8* dataBfr, uint16 dataOffset, uint16 *rspDataSize);
		
		typedef enum
		{
			PD_COMM_MODE_UNKNOWN
		#if PD_PARAM_ETH_ENABLED
			,PD_COMM_MODE_ETH
		#endif
		#if PD_PARAM_USB_ENABLED
			,PD_COMM_MODE_USB
		#endif
		#if PD_PARAM_UART_ENABLED
			,PD_COMM_MODE_UART
		#endif
		} PD_COMM_MODE;
		
		#if !defined(j1THIS_IS_MAIN_APPLICATION)
			extern
		#endif
			PD_COMM_MODE	PD_comm_mode;

	#endif	// (PD_PARAM_BL_SELECT == PD_PARAM_BL_SELECT_J1UBL)	

#endif	// defined(CYDEV_BOOTLOADER_IO_COMP)

#endif	// !defined(PD_H)
