//=====================================================================
//
//	PD_CmdXML.h - j1UBL project design command xml dictionary
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#ifndef PD_CMDXML_H	// include just once
#define PD_CMDXML_H
	
#include <project.h>

	enum
	{
		CMDXML_DEBUG = 1,
		CMDXML_D,
		CMDXML_HELP,
		CMDXML_STATUS,
		CMDXML_CONFIG,
		CMDXML_STATS,
		CMDXML_REBOOT,
		CMDXML_EXIT
	};

	j1XML_DICT_ELEM_GEN(CmdXML_debug, CMDXML_DEBUG, "debug", 0, NULL);

	enum
	{
		CMDXML_D_S = 1,
		CMDXML_D_L,
	};
	j1XML_DICT_ATTR_GEN(CmdXML_d_s, CMDXML_D_S, "s", j1XML_DICT_ATYPE_STRING,  1, 8, 0, NULL);
	j1XML_DICT_ATTR_GEN(CmdXML_d_l, CMDXML_D_L, "l", j1XML_DICT_ATYPE_STRING,  1, 3, 0, NULL);
	j1XML_DICT_ATTR2_GEN(CmdXML_d_aTbl, CmdXML_d_s, CmdXML_d_l);
	j1XML_DICT_ELEM_GEN(CmdXML_d, CMDXML_D, "d", j1VSIZEOF(CmdXML_d_aTbl), CmdXML_d_aTbl);

	j1XML_DICT_ELEM_GEN(CmdXML_help, CMDXML_HELP, "help", 0, NULL);

	j1XML_DICT_ELEM_GEN(CmdXML_status, CMDXML_STATUS, "status", 0, NULL);

	j1XML_DICT_ELEM_GEN(CmdXML_config, CMDXML_CONFIG, "config", 0, NULL);

	j1XML_DICT_ELEM_GEN(CmdXML_stats , CMDXML_STATS , "stats" , 0, NULL);

	j1XML_DICT_ELEM_GEN(CmdXML_reboot, CMDXML_REBOOT, "reboot", 0, NULL);

	j1XML_DICT_ELEM_GEN(CmdXML_exit  , CMDXML_EXIT  , "exit"  , 0, NULL);

#ifdef j1THIS_IS_MAIN_APPLICATION
//	const J1XML_DICT_ELEM const * const CmdXML_eTbl[] = { &CmdXML_debug, &CmdXML_d, &CmdXML_help, &CmdXML_status, &CmdXML_config, &CmdXML_stats, &CmdXML_network, &CmdXML_string, &CmdXML_save, &CmdXML_time, &CmdXML_dump, &CmdXML_xml, &CmdXML_reboot, &CmdXML_exit };
	const j1XML_DICT_ELEM const * const CmdXML_eTbl[] = { &CmdXML_debug, &CmdXML_d, &CmdXML_help, &CmdXML_status, &CmdXML_config, &CmdXML_stats, &CmdXML_reboot, &CmdXML_exit };
	const int	const CmdXML_eTbl_size = j1VSIZEOF(CmdXML_eTbl);
#else
	extern j1XML_DICT_ELEM const * const CmdXML_eTbl[];
	extern int	const CmdXML_eTbl_size;
#endif

void CmdXML_Init();

j1XML_RESULT	CmdXML_Validate(j1XML_ELEMENT *element);

#endif		// PD_CMDXML_H
