/*******************************************************************************
* File Name: PD_USBFS_vnd.c
* Version 2.80
*
* Description:
*  USB vendor request handler.
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "PD_USBFS.h"
#include "PD_USBFS_pvt.h"

#if(PD_USBFS_EXTERN_VND == PD_USBFS_FALSE)


/***************************************
* Vendor Specific Declarations
***************************************/

/* `#START VENDOR_SPECIFIC_DECLARATIONS` Place your declaration here */

/* `#END` */


/*******************************************************************************
* Function Name: PD_USBFS_HandleVendorRqst
********************************************************************************
*
* Summary:
*  This routine provide users with a method to implement vendor specific
*  requests.
*
*  To implement vendor specific requests, add your code in this function to
*  decode and disposition the request.  If the request is handled, your code
*  must set the variable "requestHandled" to TRUE, indicating that the
*  request has been handled.
*
* Parameters:
*  None.
*
* Return:
*  requestHandled.
*
* Reentrant:
*  No.
*
*******************************************************************************/
uint8 PD_USBFS_HandleVendorRqst(void) 
{
    uint8 requestHandled = PD_USBFS_FALSE;

    if ((CY_GET_REG8(PD_USBFS_bmRequestType) & PD_USBFS_RQST_DIR_MASK) == PD_USBFS_RQST_DIR_D2H)
    {
        /* Control Read */
        switch (CY_GET_REG8(PD_USBFS_bRequest))
        {
            case PD_USBFS_GET_EXTENDED_CONFIG_DESCRIPTOR:
                #if defined(PD_USBFS_ENABLE_MSOS_STRING)
                    PD_USBFS_currentTD.pData = (volatile uint8 *)&PD_USBFS_MSOS_CONFIGURATION_DESCR[0u];
                    PD_USBFS_currentTD.count = PD_USBFS_MSOS_CONFIGURATION_DESCR[0u];
                    requestHandled  = PD_USBFS_InitControlRead();
                #endif /*  PD_USBFS_ENABLE_MSOS_STRING */
                break;
            default:
                break;
        }
    }

    /* `#START VENDOR_SPECIFIC_CODE` Place your vendor specific request here */

    /* `#END` */

    return(requestHandled);
}


/*******************************************************************************
* Additional user functions supporting Vendor Specific Requests
********************************************************************************/

/* `#START VENDOR_SPECIFIC_FUNCTIONS` Place any additional functions here */

/* `#END` */


#endif /* PD_USBFS_EXTERN_VND */


/* [] END OF FILE */
