//=====================================================================
//
//	j1Conversion.h - common non-standard data conversions
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#ifndef PD_j1Conversion_H
#define PD_j1Conversion_H

#include <j1Types.h>
	
//#include <stdbool.h>
//#include <cytypes.h>
//#include <CyLib.h>

//#include <limits.h>
//#include <errno.h>

char	*j1_u8toa (uint8  Value, char *Buffer);
char	*j1_u16toa(uint16 Value, char *Buffer);
char	*j1_u32toa(uint32 Value, char *Buffer);

uint8	j1_hexatob(j1UINT16_VAL AsciiChars);
uint8	j1_btohexa_high(uint8 b);
uint8	j1_btohexa_low(uint8 b);
char	*j1_u8tohexstr(uint8 val, char *buffer);
char	*j1_u16tohexstr(uint16 val, char *buffer);

unsigned long j1_strtoul(const char *nptr, char **endptr, int base);

bool	j1_hextonib			(const char hex , uint8  *nib);
bool 	j1_hexfldtouint8	(const char *fld, uint8  *val);
bool	j1_hexfldtouint16	(const char *fld, uint16 *val);
bool	j1_hexfldtouint32	(const char *fld, uint32 *val);

char	*j1_mactostr		(uint8 *mac, char *buffer);
char	*j1_iptostr			(uint8 *ip , char *buffer);

bool	j1_strtou8			(const char *str, uint8  *val);
bool	j1_strtou16			(const char *str, uint16 *val);
bool	j1_strtou32			(const char *str, uint32 *val);
bool	j1_strtou32ex		(const char *str, uint32 *val, char **endptr, int base);

#endif	// PD_j1Conversion_H
