//=====================================================================
//
//	PD_j1HY28B.h - PD_j1HY28B h file
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(PD_j1HY28B_H)
#define PD_j1HY28B_H

#define	PD_j1HY28B_PARAM_J1GFX_INSTANCE	PD_j1GFX
#define	PD_j1HY28B_PARAM_J1GFX_LIB		j1GFX
#define	PD_j1HY28B_PARAM_LCD_PAR_MODE		1
#define	PD_j1HY28B_PARAM_LCD_SPI_MODE		0
#define	PD_j1HY28B_PARAM_SENDER			0
#define	PD_j1HY28B_PARAM_RECEIVER			0
#define	PD_j1HY28B_PARAM_TOUCH_SPI_ENABLE	0
#define	PD_j1HY28B_PARAM_TOUCH_SPI_SHARED	0
#define	PD_j1HY28B_PARAM_TOUCH_UP_PRE_CNT	100
#define	PD_j1HY28B_PARAM_TOUCH_UP_PST_CNT	100
#define	PD_j1HY28B_PARAM_TOUCH_DELTA_MAX	3
	
#include "PD_j1GFX.h"
#include "PD_j1HY28B_LCD.hh"
#include "PD_j1HY28B_Touch.hh"

//---------------------------------------------------------------------
//	PD_j1HY28B_LCD hardware ctrl
//---------------------------------------------------------------------

typedef struct _PD_j1HY28B_CTRL
{
	j1GFX_HOOKS			hooks;

	j1GFX_ROTATE			currRotation;		// current rotation
	uint16						currWidth;			// current width
	uint16						currHeight;			// current height
	
	PD_j1HY28B_LCD_CTRL	LCD_Ctrl;
#if PD_j1HY28B_PARAM_TOUCH_SPI_ENABLE
	PD_j1HY28B_Touch_CTRL	Touch_Ctrl;
#endif
	
} PD_j1HY28B_CTRL;

bool PD_j1HY28B_Start(PD_j1HY28B_CTRL *HY28B_Ctrl, j1GFX_CTRL *j1GFX_Ctrl, uint8 displayType, uint8 rotate, uint32 rgb, PD_j1HY28B_Touch_CTRL *preload);

#endif	// PD_j1HY28B_H
