//=====================================================================
//
//	PD_j1HY28B_Touch.hh - HAOYU 2.8" GFX Driver
//
//	version 1.1 - 15 feb 2014
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(PD_j1HY28B_TOUCH_HH)
#define PD_j1HY28B_TOUCH_HH

//#include "PD_j1GFX.h"
	
typedef	struct	_PD_j1HY28B_Touch_Point
{
	uint16	x;
	uint16	y;
} PD_j1HY28B_Touch_Point;

typedef	struct	_PD_j1HY28B_Touch_Matrix
{
	long double	An, Bn, Cn, Dn, En, Fn, Divider;
} PD_j1HY28B_Touch_Matrix;

//---------------------------------------------------------------------
//	PD_j1HY28B_Touch hardware ctrl
//---------------------------------------------------------------------

typedef struct _PD_j1HY28B_Touch_CTRL
{
	PD_j1HY28B_Touch_Matrix	matrix;
	
	PD_j1HY28B_Touch_Point	ADC_Points[3];
	PD_j1HY28B_Touch_Point	*XY_Points;

} PD_j1HY28B_Touch_CTRL;

bool	PD_j1HY28B_Touch_Touched(void);

#if PD_j1HY28B_PARAM_TOUCH_SPI_ENABLE
bool	PD_j1HY28B_Touch_ReadADC(PD_j1HY28B_Touch_Point *point);
void	PD_j1HY28B_Touch_Calibrate(j1GFX_CTRL *j1GFX_Ctrl, PD_j1HY28B_Touch_CTRL *preload);
bool	PD_j1HY28B_Touch_CalcCalibrationMatrix(PD_j1HY28B_Touch_CTRL *touch_Ctrl);
bool	PD_j1HY28B_Touch_GetTouchXY(PD_j1HY28B_Touch_CTRL *touch_Ctrl, bool waitUp, PD_j1HY28B_Touch_Point *touchXY);
bool	PD_j1HY28B_Touch_CtrlToString(PD_j1HY28B_Touch_CTRL *touch_Ctrl, char *bfr, uint8 bfrSize);
bool	PD_j1HY28B_Touch_StringToCtrl(char *bfr, PD_j1HY28B_Touch_CTRL *touch_Ctrl);
#endif

#endif
