//=====================================================================
//
//	PD_main.h - j1UBL project design main defs
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(PD_MAIN_H_)
#define PD_MAIN_H_
	
#include <j1Types.h>
	
//#if !defined(THIS_IS_MAIN_APPLICATION)
//	#define	GLOBALQUALIFY	extern
//#else
//	#define	GLOBALQUALIFY
//#endif

#define	IP_MAC	PD_ETH0_MAC_ADDR
#define	IP_ADDR	PD_ETH0_IPV4
	
#include "PD_j1UBL_XML.h"

typedef enum
{
	UBL_CONN_TYPE_NONE = 0,
	UBL_CONN_TYPE_UART,
	UBL_CONN_TYPE_USB,
	UBL_CONN_TYPE_ETH,
} UBL_CONN_TYPE;

typedef struct __UBL_CONFIG_BLOCK
{
	bool			bootOption;		// stay in bootloader
//	IP_ADDR_CONTROL	ipAddrControl;	// HAL switch setting
	
	j1UBL_TOKEN_UBL	token;

	bool			pwdValidated;	// has connection validated?
	UBL_CONN_TYPE	connType;		// last connection type
//	DWORD_VAL		lastIPAddr;		// last IP addr
} UBL_CONFIG_BLOCK;

j1GLOBALQUALIFY	UBL_CONFIG_BLOCK	ublConfigBlock;

//---------------------------------------------------------------------
//	structures
//---------------------------------------------------------------------

typedef struct _APP_INFO
{
	uint32		devID;
	uint8		devRev;
	uint8		chkSum;
	uint32		appLength;		// just used for boolean (!= 0)
	uint16		appID;
	uint16		appVer;
	uint32		appCustom;
	uint16		appTime;
	uint16		appDate;
} APP_INFO;

typedef struct _APP_FLASH_ROW
{
	uint8		arrayID;
	uint16		rowNum;
	uint16		dataLen;
	uint8		dataRow[CYDEV_FLS_ROW_SIZE];
	uint8		chkSum;
} APP_FLASH_ROW;

//---------------------------------------------------------------------
//	global data
//---------------------------------------------------------------------

APP_INFO	currAppInfo;
j1Put_CTRL	*__pC;

#if PD_PARAM_SF_ENABLED
	PD_j1SpiFlash_CTRL	PD_j1SpiFlash_Ctrl;
#endif

#endif
