/*******************************************************************************
* File Name: .h
* Version 2.50
*
* Description:
*  This private header file contains internal definitions for the SPIM
*  component. Do not use these definitions directly in your application.
*
* Note:
*
********************************************************************************
* Copyright 2012-2015, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SPIM_PVT_PD_microSD_iSPIM_H)
#define CY_SPIM_PVT_PD_microSD_iSPIM_H

#include "PD_microSD_iSPIM.h"


/**********************************
*   Functions with external linkage
**********************************/


/**********************************
*   Variables with external linkage
**********************************/

extern volatile uint8 PD_microSD_iSPIM_swStatusTx;
extern volatile uint8 PD_microSD_iSPIM_swStatusRx;

#if(PD_microSD_iSPIM_TX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 PD_microSD_iSPIM_txBuffer[PD_microSD_iSPIM_TX_BUFFER_SIZE];
    extern volatile uint8 PD_microSD_iSPIM_txBufferRead;
    extern volatile uint8 PD_microSD_iSPIM_txBufferWrite;
    extern volatile uint8 PD_microSD_iSPIM_txBufferFull;
#endif /* (PD_microSD_iSPIM_TX_SOFTWARE_BUF_ENABLED) */

#if(PD_microSD_iSPIM_RX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 PD_microSD_iSPIM_rxBuffer[PD_microSD_iSPIM_RX_BUFFER_SIZE];
    extern volatile uint8 PD_microSD_iSPIM_rxBufferRead;
    extern volatile uint8 PD_microSD_iSPIM_rxBufferWrite;
    extern volatile uint8 PD_microSD_iSPIM_rxBufferFull;
#endif /* (PD_microSD_iSPIM_RX_SOFTWARE_BUF_ENABLED) */

#endif /* CY_SPIM_PVT_PD_microSD_iSPIM_H */


/* [] END OF FILE */
